/* Copyright (c) 2009-2010 Ondrej Donek.
   See the file LICENSE.txt for licensing information. */

const tbNOTIFICATION_ID = "tbnotes-note-notification";
var tbNotesAttachMenuitems = new Array();

var tbNotesComposerOverlay = {
	update: function() {
		let msgUri = gMsgCompose.originalMsgURI;
		let messenger = Components.classes["@mozilla.org/messenger;1"].
				createInstance(Components.interfaces.nsIMessenger);
		let msg = messenger.messageServiceFromURI(msgUri).messageURIToMsgHdr(msgUri);
		let msgDesc = {
			key     : msg.messageKey,
			subject : msg.subject,
			id      : msg.messageId
		};
		
		if(!tbNotesDb.__dbInitialized) {
			tbNotesDb.init();
		}
		
		let notes = tbNotesDb.getNotesBySelectedMsg(msgDesc);
		
		if(notes.length > 0) {
			let menupopup = document.getElementById("button-attachPopup");
			
			// Remove our old menuitems			
			for(let i in tbNotesAttachMenuitems) {
				menupopup.removeChild(tbNotesAttachMenuitems[i]);
			}
			tbNotesAttachMenuitems = new Array();
			
			// Create new menuitems
			let menuseparator = document.createElement("menuseparator");
			menupopup.appendChild(menuseparator);
			tbNotesAttachMenuitems.push(menuseparator);
			
			for(let i in notes) {
				let note = notes[i];
				
				let menuitem = document.createElement("menuitem");
				menuitem.setAttribute("label", note.mTitle);
				menuitem.setAttribute("tooltiptext", tbNotes.mStrbundle.getString("convertNoteToAttchmentTip"));
				menuitem.setAttribute("oncommand", "tbNotesComposerOverlay.attachNote(event, '" + note.mId + "');");
				menuitem.setAttribute("class", "menuitem-iconic icon-showNotesView");
				menupopup.appendChild(menuitem);
				tbNotesAttachMenuitems.push(menuitem);
			}
		}
		// TODO tbNotesUtils.removeTempFiles();
	},
	
	attachNote: function(aEvent, aId) {
		// Stop the original event!
		if(aEvent) {
			aEvent.preventDefault();
			aEvent.stopPropagation();
		}
		
		// get selected edit mode
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
				getService(Components.interfaces.nsIPrefBranch);
		var type = prefs.getCharPref("extensions.tbnotes.note_dialog_editor_mode");
		type = (type == "plain") ? "text" : "html";
		
		// get the instance of tbNotesNotePrototype
		var note = tbNotesDb.getNote(aId);
		if(note == null) return;
		
		// create temporary file from the note
		var tmpfile = tbNotesUtils.createTempFileForNote(note, type);
		
		// create attachment 
		var fph = Components.classes["@mozilla.org/network/io-service;1"].
				getService(Components.interfaces.nsIIOService).
				getProtocolHandler("file").
				QueryInterface(Components.interfaces.nsIFileProtocolHandler);
		let attachment = Components.classes["@mozilla.org/messengercompose/attachment;1"].
				createInstance(Components.interfaces.nsIMsgAttachment);
		attachment.url = fph.getURLSpecFromFile(tmpfile);
		
		// and append it to the message
		AddUrlAttachment(attachment);
	}

}; // End of tbNotesComposerOverlay


// ============================================================================
// Add on load event listener

window.addEventListener("focus", tbNotesComposerOverlay.update, false);
